<template>
    <div>
        <h1>Hanzovo TodoApp</h1>
        <input autofocus type="text" placeholder="Zadej úkol" class="todo-input" v-model="newTodo" @keyup.enter="addTodo">
        <transition-group name="fade" enter-active-class="animated fadeInUp" leave-active-class="animated fadeOutDown">
            <!-- Zde mám v cyklu zobrazené všechny todos, nově budu filtrovat na základě zvolení uživatele místo in todos budu mít in todosFiltered -->
            <!-- Pomocí props :todo, :index posílám data dítěti jako objekt který si definuji jako typ objekt v dítěti props -->
            <todo-item v-for="todo in todosFiltered" :key="todo.id" :todo="todo" :index="index" :checkAll="!anyRemaining" />
               
        </transition-group>
         <div class="extra-container">
            <todo-check-all />
            <todo-items-remaining />
        </div>

        <div class="extra-container">
            <todo-filtered></todo-filtered>

            <div>
                <transition name="fade">
                <todo-clear-completed></todo-clear-completed>
                </transition>
            </div>
        </div> <!-- end extra-container -->
    </div>
</template>

<script>
    const STORAGE_KEY = 'vue-todo-app-storage'

    import TodoItem from './TodoItem.vue'
    import TodoItemsRemaining from './TodoItemsRemaining.vue'
    import TodoCheckAll from './TodoCheckAll.vue'
    import TodoFiltered from './TodoFiltered.vue'
    import TodoClearCompleted from './TodoClearCompleted.vue'

    export default {
       
        name: 'todo-list',
        components: {
            TodoItem,
            TodoItemsRemaining,
            TodoCheckAll,
            TodoFiltered,
            TodoClearCompleted
        },
        data() {
            return {
                newTodo: '',
                idForTodo: 4,
                
            }
        },
       
        //Computed properties a methody je skoro to samé
        computed: {
          
           anyRemaining() {
                return this.$store.getters.remaining != 0
            },
            todosFiltered() {
               
                return this.$store.getters.todosFiltered
            },
            
        },
      
        methods: {
            addTodo() {
            if (this.newTodo.trim().length == 0) {
                return
            }

            this.$store.dispatch('addTodo', {
                id: this.idForTodo,
                title: this.newTodo,
            })

            this.newTodo = ''
            this.idForTodo++
            },
        }
    }
</script>

<style lang="scss" scoped>

</style>